if (isObject(ECMShowHUD))
	ECMShowHUD.delete();

new ScriptObject(ECMShowHUD) {

	class = ECMShowHUD;

	Version = "3.0";
	DisplayName = "ECM Show Menu HUD";

};


//Chat Menu Handler Functions__________________________________________________________________________
//-------------------------------------------------------------------------------------------------------

	//This Function gets Bound to a key
	function activateECMMenuHud(%make){
	
		if ($pref::TracerECM::OperationalMode == 2) { //Normal Mode brings up the legacy menu
			
			activateChatMenuHud(2); //See TracerECMCore.cs. The code 2 is an over-ride that tells it to call the original version, un-modded
		
		} else if(%make && !TaskHudDlg.isVisible()) {
			
			ECMShowHUD.showMenuHud();

		}                         
	}

	//This function begins the complicated system of showing the Bind HUD by showing the root
	function ECMShowHUD::showMenuHud() {

		//Show the Bind Menu HUD
		Canvas.pushDialog(ECMMenuHudDlg);

		//Set its visibility to true
		ECMMenuHudDlg.setVisible(true);

		//Fill the HUD with the root list of Binds and Submenus
		ECMShowHUD.setMenu("TracerECM", ECMenuBuild.RootMenu);
	}
	
	function ECMShowHUD::setMenu( %this, %name, %menu ) {
		for ( %i = 0; %i < ECMShowHUD.MenuHudLineCount; %i++ )
			ECMMenuHud.remove( ECMShowHUD.MenuHudText[%i] );

		
		
		// First add the menu title line:
		ECMShowHUD.MenuHudText[0] = new GuiTextCtrl() {
			profile = "GuiHudVoiceMenuProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 3";
			extent = "165 20";
			minExtent = "8 8";
			visible = "1";
			setFirstResponder = "0";
			modal = "1";
			helpTag = "0";
			text = "\c2" @ %name @ " Menu:";
		};
		ECMMenuHud.add( ECMShowHUD.MenuHudText[0] );

		// Now add all of the menu options:
		%i = 0;
		for ( %option = 0; %option < %menu.optionCount; %option++ ) {
			%yOffset = ( %i * 15 ) + 18;
			%commandObj = %menu.command[%option];
			%showIt = false;
			
			if (%commandObj.startVoicePack !$= "")
				%showIt = true;
							
			if (%commandObj.isVoicePackItem)
				%showIt = true;
			
			if (%commandObj.cannedChat !$= "")
				%showIt = true;

			if (!%showIt && (%menu.isMenu[%option] != 1)) {
				if ($pref::TracerECM::VoiceMode == 1) {
					//NullVoice
					%text = %commandObj.nullChatText[TracerECM.PlayerVoiceNum];
					%sound = %commandObj.nullChatSound[TracerECM.PlayerVoiceNum];
					%showIt = ((%text !$= "") && (%sound !$= ""));
				} else {
					//Normal Enhanced Chat
					%text = %commandObj.chatText[TracerECM.PlayerVoiceNum];
					%sound = %commandObj.chatSound[TracerECM.PlayerVoiceNum];
					//echo("\"" @ %text @ "\" - \"" @ %sound @ "\"");
					%showIt = (((%text !$= "") && (%sound !$= "")) || (%menu.command[%option].cannedChat !$= ""));
				}
			} else {
				%showIt = true;
			}

			if (%showIt) {
			
				%i++;

				if ( %menu.isMenu[%option] == 1 ) {
					ECMShowHUD.MenuHudText[%i] = new GuiTextCtrl() {
						profile = "GuiHudVoiceMenuProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "5 " @ %yOffset;
						extent = "165 20";
						minExtent = "8 8";
						visible = "1";
						setFirstResponder = "0";
						modal = "1";
						helpTag = "0";
						text = "  " @ %menu.option[%option];
					};
				}
				else {
					ECMShowHUD.MenuHudText[%i] = new GuiTextCtrl() {
						profile = "GuiHudVoiceCommandProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "5 " @ %yOffset;
						extent = "165 20";
						minExtent = "8 8";
						visible = "1";
						setFirstResponder = "0";
						modal = "1";
						helpTag = "0";
						text = "  " @ %menu.option[%option];
					};
				}
				ECMMenuHud.add( ECMShowHUD.MenuHudText[%i] );

			}
		}

		ECMShowHUD.MenuHudLineCount = %i + 1;

		//Store Current Position (HudMover Compat)
		%guix = getword(ECMMenuHud.position, 0);
		%guiy = getword(ECMMenuHud.position, 1);
		
		//Calculate HUD height
		%height = ( ECMShowHUD.MenuHudLineCount * 15 ) + 8;
		
		//Store Width
		%width = getword(ECMMenuHud.extent, 0);
		
		//ECM has 2 modes of "expansion": UP (false, default) and DOWN (true, set by user)
		//$pref::TracerECM::MenuExpandMode
		if (!$pref::TracerECM::MenuExpandMode) {
		  //Naosyth - Changed this so it actually works.
                  %MaxY = getWord($pref::Video::resolution, 1) - 20;
                  %guiy = %MaxY - %height;
		}
		// Else, do nothing to y, because its going to expand down when the extent is changed anyways.
		
		//Set new position
		ECMMenuHud.position = %guix SPC %guiy;
		

		//Set Extent
		ECMMenuHud.extent = %width SPC %height;
		%menu.bindCmd(keyboard, "anykey", "ECMShowHUD.cancelMenu();", "");
		%menu.bindCmd(keyboard, "escape", "ECMShowHUD.cancelMenu();", "");
		ECMenuBuild.CurrentMenu.pop();
		ECMenuBuild.CurrentMenu = %menu;
		%menu.push();
	}

	function ECMShowHUD::cancelMenu() {
		ECMenuBuild.CurrentMenu.pop();
		ECMenuBuild.CurrentMenu = ECMenuBuild.RootMenu;
		Canvas.popDialog(ECMMenuHudDlg);
		ECMMenuHudDlg.setVisible(false);
		//Reset dimensions to Xx8 and move menu if applicable
		if (!$pref::TracerECM::MenuExpandMode) {
		
			%guiy = getword(ECMMenuHud.position, 1);
			
			%guiy = %guiy + getword(ECMMenuHud.extent, 1) - 30;
			
			ECMMenuHud.position = getword(ECMMenuHud.position, 0) SPC %guiy;
		
		}
		ECMMenuHud.extent = getword(ECMMenuHud.extent, 0) SPC "30";
	}

//End Chat Menu Handler Functions________________________________________________________________________
//-----------------------------------------------------------------------------------------------------
